package cz.upol;

//kazdy bus je dopravni prostredek a ma registraci
// navic kazdy autobus ma svetla
public class Bus extends RegisteredVehicle implements HasLights {
    
    // zastavky, ktere autobus obsluhuje (jinam nemuze jet)
    private String[] busStops;
    
    //nejake dalsi vlastnosti autobusu
    private boolean lightsOK = true;
    private boolean tiresOK = true;
    private boolean engineOK = true;

    public Bus(String plateNo, String color, String location, int maxSpeed, int minSpeed, int capacity, String[] busStops) {
        super(plateNo, color, location, maxSpeed, minSpeed, capacity);
        this.busStops = busStops;
    }
    
    
    //prepisujeme metodu na zmenu lokace, protoze autobus muze jen na sve zastavky
    @Override
    public boolean setLocation(String location){
        for(String stop : busStops){
            if(stop.equals(location)){
                return super.setLocation(location); // pokud je pozadovana lokace prijtalna zastavka, tak preposleme natavaovani lokace ke zpracovani metode predka
            }
        }
        return false; //jinak to rovnou odmitneme   
    }

    
    //metody vyzadovane implementovanymi rozhranimi
    @Override
    public boolean checkLights() {
      return lightsOK;
    }

    @Override
    public void repairLights() {
        if(!lightsOK){
            doServiceCheckUp();
        }
    }
    
    //nejake dalsi pomocne metody
    
    private void doServiceCheckUp(){
        lightsOK = true;
        tiresOK = true;
        engineOK = true;
        //...
    }
}
