package cz.upol;

//kazde auto je dopravni prostredek s SPZ (Car is a RegisteredVehicle)
//navic se o auto clovek muze start sam a auto ma svetla
public class Car extends RegisteredVehicle implements SelfMaintanable, HasLights {

    //auto ma kufr, coz obecny dopr. prostredek mit nemusi
    private int cargoSpaceCapacity; 
    //mam dvoje svetla a jsou ve stavu: true - ok, false - ko
    private boolean[] lights = new boolean[]{true, true}; 
    
     
    public Car(String plateNo, String color, String location, int cargoSpaceCapacity, int maxSpeed, int minSpeed, int capacity) {
        super(plateNo, color, location, maxSpeed, minSpeed, capacity);
        this.cargoSpaceCapacity = cargoSpaceCapacity;
    }

    public int getCargoSpaceCapacity() {
        return cargoSpaceCapacity;
    }

    public boolean setCargoSpaceCapacity(int cargoSpaceCapacity) {
        if (cargoSpaceCapacity >= 0) {
            this.cargoSpaceCapacity = cargoSpaceCapacity;
            return true;
        }
        return false;
    }

    //metody vyzadovane implementovanymi rozhranimi
    
//    @Override
//    public boolean prepareToUse() {
//        if(! isReady()){
//           repairLights();
//       } 
//       return true;
//    } // tato metoda je zakomentovana  - tedy zde neni implementovana
        // a tedy se pouzije default implementace z rozhrani.

    @Override
    public boolean isReady() {
        return checkLights();

    }

    @Override
    public boolean checkLights() {
        return lights[0] && lights[1];
    }

    @Override
    public void repairLights() {
        lights[0] = true;
        lights[1] = true;

    }
}
