package cz.upol;

//spolecny predek vsech dopravnich prostredku.
//Nechceme ale, aby jej mohl uzivatel nasi knihovny vytvorit
//- neni to skutecne existujici typ vozidla -> abstraktni trida (proc by neslo interface?)
public abstract class Vehicle {

    private String color;
    private int speed = 0;
    private Human[] crew;
    private String location;
    
    private int maxSpeed;
    private int minSpeed;
    private int capacity;
    private int crewSize = 0; //vychozi hodnota
   
    public Vehicle(String color, String location) {
        this.color = color;
        this.crew = crew;
        this.location = location;
        maxSpeed = 120;
        minSpeed = -20;
        capacity = 4;
        crew = new Human[capacity];
    }

    public Vehicle(String color, String location, int maxSpeed, int minSpeed, int capacity) {
        this.color = color;
        this.crew = crew;
        this.location = location;
        this.maxSpeed = maxSpeed;
        this.minSpeed = minSpeed;
        this.capacity = capacity;
        crew = new Human[capacity];
    }

    
    //gettery a settery
    public String getColor() {
        return color;
    }

    public final void setColor(String color) {
        this.color = color;
    }

    public int getSpeed() {
        return speed;
    }

    public boolean setSpeed(int speed) {
        if(speed >= minSpeed && speed <= maxSpeed){
            this.speed = speed;
            return true;
        }
        return false;
    }

    

    public String getLocation() {
        return location;
    }

    public boolean setLocation(String location) {
        this.location = location;
        return true;
    }
    
    
    //kapacita dop. prostredku ma jen getter - nechceme, aby ji nekdo mohl menit
    public int getCapacity(){
        return capacity;
    }
    
    
    //crew nema ani getter ani setter - nikdo se k tomu nedostane
    //veskerou praci s crew kontrolujeme pres nasledujici dve metody
    public boolean board(Human human){
        if(speed == 0 && crewSize < capacity){
            crew[crewSize - 1] = human;
            crewSize++;
            return true;
        }
        return false;
    }
    
    
    public boolean disembark(Human human){
        if(speed == 0) {
            for(int i = 0; i < crewSize; i++){
                Human h = crew[i];
                if(h.equals(human)){
                    for (var j = i+1; j < crewSize; j++){
                        crew[j-1] = crew[j];
                    }
                    crewSize--;
                    crew[crewSize] = null;
                    return true;
                }
                
            }
        }
        return false;
    }

    @Override
    public String toString() {
        return "Dopravni prostredek{" + "barva=" + color + '}';
    }

    
    
  
    
}
